/*************************************************************************************************
 * curia.o
 * QDBMγĥAPI
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 * 
 *    APIǤDepotγĥǤꥹ֤Ǥ롣
 *    ʣΥǡ١ե礷ưȤˤäƥӥƥ夵롣
 *    Ͻϰ¸POSIXXPGUNIXɸˤʤ٤碌褦ˤƤ롣
 *    ƤΥޥҤ CR_ ̾ CR 򡢤ʳγ̾ cr Ƭ˻ġ
 *
 * Ūջ
 *    Ρ֥ȡפȤѸϡmalloc/calloc/realloc ΰݤ뤳Ȥ̣
 *      Ƥ롣ͤȤƥȤ줿ΰΥݥ󥿤֤ؿ¿뤬ΰ
 *      ǤϸƤӽФ¦餦Ȥˤʤ롣
 *    åɥդǤϤʤꥨȥȤǤʤ
 *    intХȤ򲼲ϤǤưʤ
 *************************************************************************************************/


/* Ƚ */
#ifndef _CURIA_H
#define _CURIA_H


#include <depot.h>
#include <stdlib.h>



/*************************************************************************************************
 * API
 *  ǡ١Ѥ뤿ˤϡcropen ǥǡ١ե򳫤ͤǤCURIA
 *    Υݥ󥿤ϥɥȤѤ롣
 *  ǡ١Ѥ顢ɬ crclose Ĥ٤Ǥ롣
 *  饤ɤ߽ξѥ⡼ɡˤǥǡ١ե򳫤ݤˤϤΥǥ쥯ȥФ¾
 *    å졢꡼ɤ߹ѥ⡼ɡˤǳݤˤ϶ͭå롣κݤ
 *    ϳΥåޤǥ֥å롣
 *  ǡ١̿Ūʥ顼ϡʸ夽ΥϥɥФ crclose Ƥ
 *    ϲ⤻˥顼֤
 *  CURIA¤ΤΥФľܻȤ뤳ȤϿ侩ʤ
 *************************************************************************************************/


typedef enum {                           /* ץ⡼ɤ */
  CR_OREADER = 1 << 0,                   /* ɤ߹ */
  CR_OWRITER = 1 << 1,                   /* ɤ߽ξ */
  CR_OCREAT = 1 << 2,                    /* ʤк */
  CR_OTRUNC = 1 << 3                     /* äƤ⿷ */
} CROMODE;

typedef enum {                           /* ʣ񤭹 */
  CR_DOVER,                              /* 񤭤 */
  CR_DKEEP,                              /* ¸ͤݻ */
  CR_DCAT                                /* ¸ͤ˲ä */
} CRDMODE;

typedef struct {                         /* ǡ١ϥɥι¤η */
  char *name;                            /* ǥ쥯ȥ̾ */
  int wmode;                             /* 񤭹߲ǽݤ */
  DEPOT *attr;                           /* °ǡ١Υϥɥ */
  DEPOT **depots;                        /* ǥǡ١Υϥɥ */
  int dnum;                              /* ϥɥǿ */
  int inum;                              /* ƥ졼ǥǡ١ */
  int lrnum;                             /* 顼֥ȿ */
} CURIA;


/* ǡ١ǥ쥯ȥ򳫤Υϥɥ֤
   name ϥǡ١ǥ쥯ȥ̾ꤹ롣
   omode ³⡼ɤꤷCR_OREADER ʤ꡼CR_OWRITER ʤ饤Ȥʤ롣
   omode  CR_OWRITER ξ硢CR_OCREAT ޤ CR_OTRUNC ȤΥӥå¤ˤ뤳ȤǤ롣
   CR_OCREAT ϥե뤬̵˿뤳ȤؼCR_OTRUNC ϥե뤬¸ߤƤ
   ľȤؼ롣
   bnum ϥХåǿܰ¤ꤹ뤬0 ʲʤǥեͤȤ롣
   dnum ǥǡ١οꤹ뤬0 ʲʤǥեͤȤ롣
   ͤʤǡ١ϥɥǤꡢ顼ʤ NULL Ǥ롣 */
CURIA *cropen(const char *name, CROMODE omode, int bnum, int dnum);


/* ǡ١ǥ쥯ȥĤ롣
   curia ϥǡ١ϥɥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   ĤϥɥΰϲΤǡʸѤ뤳ȤǤʤʤ롣 */
int crclose(CURIA *curia);


/* ǡ١˥쥳ɤɲä롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   vbuf ͤΥǡΰΥݥ󥿤ꤹ롣
   vsiz ͤΥǡΰΥХȿǻꤹ뤫-1 ʤ vbuf ʸĹȤʤ롣
   dmode  CR_DOVER  CR_DKEEP  CR_DCAT ǡ¸쥳ɤȽʣݤꤹ롣
   CR_DOVER ϴ¸Υ쥳ɤͤ񤭤CR_DKEEP ϴ¸Υ쥳ɤĤƥ顼֤
   CR_DCAT ϻꤵ줿ͤ¸ͤ˲ä롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */   
int crput(CURIA *curia, const char *kbuf, int ksiz, const char *vbuf, int vsiz, CRDMODE dmode);


/* ǡ١쥳ɤ롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   Υ쥳ɤʤ⵶֤ */
int crout(CURIA *curia, const char *kbuf, int ksiz);


/* ǡ١쥳ɤͤФ롣
   curia ϥǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   start ͤΰ褫ФǽΥХȤΥեåȤꤹ롣
   max ͤΰ褫Ф륵Хȿǻꤹ뤫ʤ̵¤Ȥʤ롣
   sp  NULL ǤʤСλФΰΥХȿǼ롣
   ͤʤͤǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣
   Υ쥳ɤʤ NULL ֤
   ФȤͤΥ start 꾮äˤϳȤߤʤʤ
   ͤΰϡºݤˤϣХ¿ݤƽüʸ֤ΤǡʸȤѤǤ롣 */
char *crget(CURIA *curia, const char *kbuf, int ksiz, int start, int max, int *sp);


/* ǡ١ˤ쥳ɤͤΥ롣
   curia ϥǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤϳ쥳ɤͤΥХȿǤꡢʤäꡢ顼ξ -1 Ǥ롣 */
int crvsiz(CURIA *curia, const char *kbuf, int ksiz);


/* ǡ١ΥΥƥ졼롣
   curia ϥǡ١ϥɥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */
int criterinit(CURIA *curia);


/* ǡ١ΥΥƥ졼鼡ΥФ
   curia ϥǡ١ϥɥꤹ롣
   sp  NULL ǤʤСλФΰΥХȿǼ롣
   ͤʤ饭ǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣
   ƥ졼ǸޤǤƳΥ쥳ɤʤ NULL ֤
   ͤΰϡºݤˤϣХ¿ݤƽüʸ֤ΤǡʸȤѤǤ롣 */
char *criternext(CURIA *curia, int *sp);


/* ǡ١Υ饤Ȥꤹ롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   asiz ϥ饤Ȥδܥꤹ롣
   aunit ϥ饤ȤΥ˥åȥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   쥳ɤͤǼΰΥϡ饤Ȥܿǳݤ롣
   饤ȤͤΥ˥åȥã뤴Ȥ˴ܥܲäƻФ롣
   饤Ȥϥǡ١¸ʤΤǡǡ١򳫤٤˻ꤹ뤳ȡ */
int crsetalign(CURIA *curia, int asiz, int aunit);


/* ǡ١Ƥե뤪ӥǥХƱ롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */
int crsync(CURIA *curia);


/* ǡ١Ŭ롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   bnum ϥХåοǿꤹ뤬0 ʲʤ쥳ɿ˺Ŭͤꤵ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣 */
int croptimize(CURIA *curia, int bnum);


/* ǡ١֤̾
   curia ϥǡ١ϥɥꤹ롣
   ͤʤͤǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣 */
char *crname(CURIA *curia);


/* ǥǡ١Υե륵ιפ֤
   curia ϥǡ١ϥɥꤹ롣
   ͤʤեΥιס顼ʤ -1 Ǥ롣 */
int crfsiz(CURIA *curia);


/* ǥǡ١ΥХåǿιפ֤
   curia ϥǡ١ϥɥꤹ롣
   ͤʤХåǿιס顼ʤ -1 Ǥ롣 */
int crbnum(CURIA *curia);


/* ǡ١ΥХåǿιפ֤
   curia ϥǡ١ϥɥꤹ롣
   ͤʤХåǿιס顼ʤ -1 Ǥ롣 */
int crbusenum(CURIA *curia);


/* ǥǡ١Υ쥳ɿιפ֤
   curia ϥǡ١ϥɥꤹ롣
   ͤʤ쥳ɿιס顼ʤ -1 Ǥ롣 */
int crrnum(CURIA *curia);


/* 顼֥ѥǡ١˥쥳ɤɲä롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   vbuf ͤΥǡΰΥݥ󥿤ꤹ롣
   vsiz ͤΥǡΰΥХȿǻꤹ뤫-1 ʤ vbuf ʸĹȤʤ롣
   dmode  CR_DOVER  CR_DKEEP  CR_DCAT ǡ¸쥳ɤȽʣݤꤹ롣
   CR_DOVER ϴ¸Υ쥳ɤͤ񤭤CR_DKEEP ϴ¸Υ쥳ɤĤƥ顼֤
   CR_DCAT ϻꤵ줿ͤ¸ͤ˲ä롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   ̾Υǡ١ȥ顼֥ѤΥǡ١ϥ֤ۤʤꡢ顼֥Ȥ
   ɲˤä̾Υ쥳ɤ˾񤭤ɲä뤳ȤϤʤ */
int crputlob(CURIA *curia, const char *kbuf, int ksiz, const char *vbuf, int vsiz, CRDMODE dmode);


/* 顼֥ѥǡ١쥳ɤ롣
   curia ϥ饤³ǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤʤ鿿Ǥꡢ顼ʤ鵶Ǥ롣
   Υ쥳ɤʤ⵶֤
   ̾Υǡ١ȥ顼֥ѤΥǡ١ϥ֤ۤʤꡢ顼֥Ȥ
   ˤä̾Υ쥳ɤκ뤳ȤϤʤ */
int croutlob(CURIA *curia, const char *kbuf, int ksiz);


/* 顼֥ѥǡ١쥳ɤͤФ롣
   curia ϥǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   start ͤΰ褫ФǽΥХȤΥեåȤꤹ롣
   max ͤΰ褫Ф륵Хȿǻꤹ뤫ʤ̵¤Ȥʤ롣
   sp  NULL ǤʤСλФΰΥХȿǼ롣
   ͤʤͤǼȤΰؤΥݥ󥿡顼ʤ NULL Ǥ롣
   Υ쥳ɤʤ NULL ֤
   ФȤͤΥ start 꾮äˤϳȤߤʤʤ
   ͤΰϡºݤˤϣХ¿ݤƽüʸ֤ΤǡʸȤѤǤ롣
   ̾Υǡ١ȥ顼֥ѤΥǡ١ϥ֤ۤʤꡢ顼֥Ȥ
   ˤä̾Υ쥳ɤ뤳ȤϤʤ */
char *crgetlob(CURIA *curia, const char *kbuf, int ksiz, int start, int max, int *sp);


/* 顼֥ѥǡ١ˤ쥳ɤͤΥ롣
   curia ϥǡ١ϥɥꤹ롣
   kbuf ϥΥǡΰΥݥ󥿤ꤹ롣
   ksiz ϥΥǡΰΥХȿǻꤹ뤫ʤ kbuf ʸĹȤʤ롣
   ͤϳ쥳ɤͤΥХȿǤꡢʤäꡢ顼ξ -1 Ǥ롣
   ̾Υǡ١ȥ顼֥ѤΥǡ١ϥ֤ۤʤꡢ顼֥Ȥ
   ˤä̾Υ쥳ɤ뤳ȤϤʤ */
int crvsizlob(CURIA *curia, const char *kbuf, int ksiz);



/* 顼֥ѥǡ١Υ쥳ɿ֤
   curia ϥǡ١ϥɥꤹ롣
   ͤʤ쥳ɿ顼ʤ -1 Ǥ롣 */
int crrnumlob(CURIA *curia);



#endif /* Ƚ꽪λ */


/* END OF FILE */
